function gp1 = optimize( gp, mu )
[x, flag, n_func] = optimize( gp.op, mu, [gp.x_start; gp.y_start] );
gp.mu = mu;
gp.n_eval = gp.n_eval + n_func;
gp.path = sortrows( [gp.path;[mu, x(1), x(2)]], 1 );
gp.obj_val = obj_func( gp.op, x );
gp.penalty = penalty( gp.op, x, mu );


%%
%%some graphics go here
sx = length( gp.x );
sy = length( gp.y );
[X Y] = meshgrid( gp.x, gp.y );
X = reshape( X, 1, sx*sy );
Y = reshape( Y, 1, sx*sy );

fea_ind = find( fea( gp.op, [X;Y] ) );

f = NaN * ones( 1, sx*sy );
fgrad = NaN * ones( 2, sx*sy );


f(fea_ind) = obj_func( gp.op, [X(fea_ind);Y(fea_ind)] ) + ...
		       penalty( gp.op, [X(fea_ind);Y(fea_ind)], mu ); 
fgrad(:,fea_ind) = -obj_grad( gp.op, [X(fea_ind);Y(fea_ind)] ) - ...
    pen_grad( gp.op, [X(fea_ind);Y(fea_ind)], mu );

X = reshape( X, sy, sx );
Y = reshape( Y, sy, sx );

hold( 'on' );
cla;
axis( [gp.xmin, gp.xmax, gp.ymin, gp.ymax] );
hs = pcolor( X, Y, reshape( f, sy, sx ) );
set( hs, ...
     'HitTest', 'off', ...
     'HandleVisibility', 'on' );
%hs = colorbar( 'vert' );
%set( hs, ...
%     'HitTest', 'off', ...
%     'HandleVisibility', 'on' );

%hs = mesh( X, Y, reshape( f, sy, sx ) );
%set( hs, ...
%     'HitTest', 'off', ...
%     'HandleVisibility', 'on' );

%hs = quiver( X, Y, ...
%	     fgrad(1,:), ...
%	     fgrad(2,:), ...
%	     1, ...
%	     gp.grad_color );
%set( hs, ...
%     'HitTest', 'off', ...
%     'HandleVisibility', 'on' );


%[c, hs] = contour( X, ...
%		   Y, ...
%		   reshape( f, sy, sx ) ); %, ...
		   %gp.levels );
%set( hs, ...
%     'HitTest', 'off', ...
%     'HandleVisibility', 'on' );

%hs = clabel( c, hs, 'color', gp.clab_color );
%set( hs, ...
%     'HitTest', 'off', ...
%     'HandleVisibility', 'on' );


hs = plot( x(1), x(2), sprintf( '%sx', gp.path_color ) );
set( hs, ...
     'HitTest', 'off', ...
     'HandleVisibility', 'on', ...
     'LineWidth', 2 );
     
hold( 'off' );

%%%%%%%%%%%%
% update
gp.x_start = x(1);
gp.y_start = x(2);
gp.max_penalty = mu;

gp1 = gp;
clear( 'X' );
clear( 'Y' );
clear( 'f' );