function gp = example3
%objective function
obj = 'x(1)*x(2)';
obj_grad = '[x(2);x(1)]';

%constraints
cons = {'x''*x/5-25/5', '-x(1) - x(2)'};
cons_grad = {'2*x/5', '[-1; -1]'};


%domain
x1 = -6:0.3:6;
x2 = -6:0.3:6;

%start points
x1_start = 1;
x2_start = 2;

%construct the optimization problem
gp = gr_ipa_opt( x1, x2, ...
		 ipa_opt_prob( obj, obj_grad, cons, cons_grad ), ...
		 x1_start, x2_start );
